#
# spec file for package freerdp
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define sover 2

Name:           freerdp
Version:        2.0.0~git.1463131968.4e66df7
Release:        13.1
Summary:        Remote Desktop Viewer Client
License:        Apache-2.0
Group:          Productivity/Networking/Other
Url:            http://www.freerdp.com/
Source0:        %{name}-%{version}.tar.gz
# PATCH-FIX-UPSTREAM freerdp-Fix-TALOS-issues.patch bsc#1050699 bsc#1050704 bsc#1050708 bsc#1050711 bsc#1050712 bsc#1050714 fezhang@suse.com -- Fix a bunch of secury issues: CVE-2017-2834, CVE-2017-2835, CVE-2017-2836, CVE-2017-2837, CVE-2017-2838, CVE-2017-2839 
Patch0:         freerdp-Fix-TALOS-issues.patch
Patch1:         freerdp-KB408876.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-8789.patch boo#1117965 fezhang@suse.com -- Fix CVE-2018-8789
Patch2:         freerdp-CVE-2018-8789.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-8785.patch boo#1117967 fezhang@suse.com -- Fix CVE-2018-8785
Patch3:         freerdp-CVE-2018-8785.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-8786.patch boo#1117966 fezhang@suse.com -- Fix CVE-2018-8786
Patch4:         freerdp-CVE-2018-8786.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-8787.patch boo#1117964 fezhang@suse.com -- Fix CVE-2018-8787
Patch5:         freerdp-CVE-2018-8787.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-8788.patch boo#1117963 fezhang@suse.com -- Fix CVE-2018-8788
Patch6:         freerdp-CVE-2018-8788.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-8784.patch boo#1116708 fezhang@suse.com -- Fix CVE-2018-8784
Patch7:         freerdp-CVE-2018-8784.patch
# PATCH-FIX-UPSTREAM freerdp-CVE-2018-1000852.patch boo#1120507 fezhang@suse.com -- Fix CVE-2018-1000852
Patch8:         freerdp-CVE-2018-1000852.patch
BuildRequires:  alsa-devel
BuildRequires:  cmake
BuildRequires:  cups-devel
BuildRequires:  ed
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  gstreamer-devel
BuildRequires:  gstreamer-plugins-base-devel
BuildRequires:  libopenssl-devel
BuildRequires:  libpulse-devel
BuildRequires:  libxkbcommon-devel
BuildRequires:  pcsc-lite-devel
BuildRequires:  systemd-devel
BuildRequires:  xmlto
BuildRequires:  xorg-x11-devel
BuildRequires:  zlib-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%define libname lib%{name}%{sover}

%description
FreeRDP is a client-side implementation of the Remote Desktop Protocol (RDP)
following the Microsoft Open Specifications. This package provides the client
application.

%package -n %{libname}
Summary:        Remote Desktop Viewer Library
Group:          System/Libraries
Obsoletes:      libfreerdp-1_0-plugins

%description -n %{libname}
FreeRDP is a client-side implementation of the Remote Desktop Protocol (RDP)
following the Microsoft Open Specifications. This package provides the shared
library.

%package devel
Summary:        Development Files for %{name}
Group:          Development/Libraries/C and C++
Requires:       %{libname} = %{version}

%description devel
This package contains development files necessary for developing applications
based on libfreerdp.

%prep
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

%build
find . -type f -name "*.c" -exec perl -i -pe 's{__(DATE|TIME)__}{""}g' "{}" "+"
%cmake \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DCMAKE_INSTALL_LIBDIR=%{_lib} \
    -DCMAKE_BUILD_TYPE=Release \
    -DWITH_ALSA=ON \
    -DWITH_PULSEAUDIO=ON \
    -DWITH_PCSC=ON \
    -DWITH_CUPS=ON \
    -DCMAKE_NO_BUILTIN_CHRPATH=ON \
%ifarch %ix86 x86_64
    -DWITH_SSE2=ON \
%endif
    ..
make %{?_smp_mflags} VERBOSE=1

%install
cd build
make install 'DESTDIR=%{buildroot}'
find %{buildroot} -name "*.a" -delete
%fdupes -s %{buildroot}

%post   -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc LICENSE README ChangeLog
%{_bindir}/winpr-hash
%{_bindir}/winpr-makecert
%{_bindir}/xfreerdp
%{_mandir}/man1/xfreerdp.1%{ext_man}

%files -n %{libname}
%defattr(-,root,root)
%doc LICENSE
%{_libdir}/libfreerdp-client.so.*
%{_libdir}/libfreerdp.so.*
%{_libdir}/libwinpr.so.*
%{_libdir}/libwinpr-tools.so.*

%files devel
%defattr(-,root,root)
%doc LICENSE
%{_includedir}/freerdp2
%{_includedir}/winpr2
%{_libdir}/cmake/FreeRDP2
%{_libdir}/cmake/FreeRDP-Client2
%{_libdir}/cmake/WinPR2
%{_libdir}/libfreerdp-client.so
%{_libdir}/libfreerdp.so
%{_libdir}/libwinpr.so
%{_libdir}/libwinpr-tools.so
%{_libdir}/pkgconfig/freerdp2.pc
%{_libdir}/pkgconfig/freerdp-client2.pc
%{_libdir}/pkgconfig/winpr2.pc
%{_libdir}/pkgconfig/winpr-tools2.pc

%changelog
* Wed Jan  9 2019 Felix Zhang <fezhang@suse.com>
- Add a bunch of security fixes:
  + freerdp-CVE-2018-8789.patch (boo#1117965, CVE-2018-8789)
  + freerdp-CVE-2018-8785.patch (boo#1117967, CVE-2018-8785)
  + freerdp-CVE-2018-8786.patch (boo#1117966, CVE-2018-8786)
  + freerdp-CVE-2018-8787.patch (boo#1117964, CVE-2018-8787)
  + freerdp-CVE-2018-8788.patch (boo#1117963, CVE-2018-8788)
  + freerdp-CVE-2018-8784.patch (boo#1116708, CVE-2018-8784)
  + freerdp-CVE-2018-1000852.patch (boo#1120507, CVE-2018-1000852)
* Wed Mar 21 2018 manfred.h@gmx.net
- Add freerdp-KB408876.patch as a fix for boo#1085416, boo#1087240,
  boo#1104918, CVE-2018-0886:
  + fix nla: don't use server version; see
    <https://github.com/FreeRDP/FreeRDP/commit/f8baeb72470f3ada14fdf6f8a13b67543340621b>
* Mon Jul 31 2017 fezhang@suse.com
- Add freerdp-Fix-TALOS-issues.patch: Backport 8292b45, fix a bunch
  of security issues:
  + Out-of-bounds write in license_recv() (bsc#1050714,
    CVE-2017-2834)
  + Out-of-bounds write in rdp_recv_tpkt_pdu (bsc#1050712,
    CVE-2017-2835)
  + Rdp Client Read Server Proprietary Certificate Denial of
    Service (bsc#1050699, CVE-2017-2836)
  + Client GCC Read Server Security Data DoS (bsc#1050704,
    CVE-2017-2837)
  + Client License Read Product Info Denial of Service
    Vulnerability (bsc#1050708, CVE-2017-2838)
  + Client License Read Challenge Packet Denial of Service
    (bsc#1050711, CVE-2017-2839)
* Wed May 18 2016 jengelh@inai.de
- Kill off __DATE__ from built sources.
* Tue May 17 2016 fezhang@suse.com
- Update to GNOME 3.20.2 FATE#318572
- Add obs git integration.
- Update to version 2.0.0git.1463131968.4e66df7:
  + Fixed memory leaks.
  + wfreerdp: fix name build without client interface
  + libfreerdp-codec: fix xcrush decompression, revert remote
    control fix
  + KB3153731: May 2016 DST update for Azerbaijan, Chile, Haiti and
    Morocco
  + libfreerdp-codec: make proper xcrush context reset fix
* Wed May  4 2016 fezhang@suse.com
- Update to version 2.0.0, git master branch id a7ca42e
  (FATE#319661), no upstream changelog available.
  * Warning: This is a git snapshot regarded as technical preview
    by upstream.
  * Warning: For xfreerdp, new /long-option commandline interfaces
    have replaced the old --long-option interfaces. Existing user
    scripts need to migrate to the new interfaces to avoid
    breakages.
    For more details, see:
    https://github.com/FreeRDP/FreeRDP/wiki/CommandLineInterface
  * Add Network Level Ahthentication support.
  * Add Windows Portable Runtime. For more details, see:
    http://www.freerdp.com/2012/05/24/winpr-windows-portable-runtime
  * Obsolete libfreerdp-1_0-plugins.
- Drop FindALSA.cmake: deprecated
- Drop freerdp_branch-1.0.x_fix-kpdivide-issue831.patch:
  fixed upstream, implemention now in include/freerdp/scancode.h.
- Drop freerdp-CVE-2014-0250.patch (bnc#880317):
  fixed upstream 532c420.
- Drop freerdp-CVE-2014-0791.patch (bnc#857491):
  fixed upstream f1d6afc.
- Drop freerdp-fix-FindPCSC-macro.patch:
  fixed upstream 9148af3.
- Drop freerdp-handle-null-device-name.patch (bnc#785437):
  deprecated, related implementation dropped.
  was: freerdp-fix-pulse-no-device-name.patch
* Mon Jun 23 2014 fezhang@suse.com
- Add freerdp-CVE-2014-0791.patch to fix bnc#857491
  backported from upstream commit f1d6afc
* Thu Jun 12 2014 dliang@suse.com
- Add freerdp-CVE-2014-0250.patch to fix bnc#880317
  solves CVE-2014-0250, backport from upstream
* Thu Oct 31 2013 lnt-sysadmin@lists.lrz.de
- Allow build on SLES11:
  * converted pkgconfig() BuildRequires to package names
  * added FindALSA.cmake
  * use 'make install' instead of '%%make_install' macro
* Thu Sep 12 2013 crrodriguez@opensuse.org
- build with -DOPENSSL_LOAD_CONF so among other things
  the application respects the system's openSSL configuration.
* Thu Mar  7 2013 bruno@ioda-net.ch
- Added patch for issue #811 fixing divide key (/) on keypad for
  1.0x series,
  commit https://github.com/bmiklautz/FreeRDP/commit/e0cc1e60657b5883a907e5da2f70eb27bf0b91f1
- Added changelog
  FreeRDP 1.0.2 is a maintenance release which contains several bug
  and stability fixes.
  * xfreerdp:
  * new parameter --from-stdin - prompts for unspecified arguments
    username, password, domain and host.
  * fix compability with x2go
  * fix keyboard state in remote app
  * documentation fixes
  * fixed crash when started with --authonly (#843)
  * libfreerdp-core:
  * several memory leaks and double frees were fixed
  * support for FastPath PDUs up to 32767
  * register audio only if plugin is registered
  * load extensions after argument parsing
  * libfreerdp-utils:
  * fixed crash when HOME environment variable wasn't set
  * xfreerdp-server:
  * deadlock fixed
  * accept TLSv1 and SSLv3
  * smartcard:
  * don't incorrectly set SCARD_STATE_IGNORE
  * libfreerdp-codec:
  * performance improvement
  * libfreerdp-gdi:
  * support for PatBlt DPa operation
  * plugin:
  * ignore CHANNEL_FLAG_SUSPEND/CHANNEL_FLAG_RESUME to prevent
    possible crash
  For a detailed list of changes use "git log 1.0.1..1.0.2"
  known problems:
  * If windows input language is set to german pressing the divde
    key (/) on the keypad results in minus (-) (see issue #811)
* Thu Jan 24 2013 kkaempf@suse.com
- update to 1.0.2
  - bugfix release (no changelog posted)
  - drop patches that are upstream
* Fri Dec 28 2012 dmueller@suse.com
- only enable SSE2 on x86*
* Fri Dec 28 2012 dvaleev@suse.com
- disable SSE2 for ARM as well
* Fri Dec 28 2012 dvaleev@suse.com
- disable SSE2 for powerpc
* Thu Dec 27 2012 gber@opensuse.org
- build with WITH_SSE2=ON as freerdp now uses runtime detection
  (bnc#793611)
* Thu Nov  1 2012 gber@opensuse.org
- added freerdp-fix-pulse-no-device-name.patch in order to fix a
  segfault in case device name is not provided (bnc#785437)
* Wed Oct 17 2012 gber@opensuse.org
- added freerdp-fix-linking-with-libpulse.patch in order to link
  correctly with libpulse
  (https://github.com/FreeRDP/FreeRDP/issues/418, bnc#785437)
* Sun Apr 29 2012 zawertun@gmail.com
- added freerdp-fix-incorrect-numlock-state.patch which fixes
  incorrect num lock state when connecting
  (https://github.com/FreeRDP/FreeRDP/pull/564)
* Sun Apr 22 2012 gber@opensuse.org
- added freerdp-fix-FindPCSC-macro.patch which fixes the build by
  setting PCSC_LIBRARIES and PCSC_INCLUDE_DIRS variables explicitly
  which are otherwise empty
  (https://github.com/FreeRDP/FreeRDP/issues/562)
* Thu Apr 19 2012 gber@opensuse.org
- applied fix for a bug in freerdp-fix-bitmap-cache.patch from
  upstream git
* Fri Mar 30 2012 zawertun@gmail.com
- added freerdp-fix-bitmap-cache.patch fixing a problem with the
  bitmap cache resulting in garbled images
  (https://github.com/FreeRDP/FreeRDP/issues/348)
* Wed Mar 28 2012 gber@opensuse.org
- split off -plugins subpackage
- specfile cleanup
* Tue Mar  6 2012 gankov@opensuse.org
- rewrote spec for using cmake.
- update to version 1.0.1
  - FreeRDP 1.x series is a complete rewrite now licensed under
    the Apache License 2.0
  - RemoteFX
  - Both encoder and decoder
  - SSE2 and NEON optimization
  - NSCodec
  - RemoteApp
  - Working, minor glitches
  - Multimedia Redirection
  - ffmpeg support
  - Network Level Authentication (NLA)
  - NTLMv2
  - Certificate validation
  - FIPS-compliant RDP security
  - new build system (cmake)
  - added official logo and icon
* Fri Dec  2 2011 gber@opensuse.org
- add explicit dependency on libtool
* Thu Dec  1 2011 coolo@suse.com
- add automake as buildrequire to avoid implicit dependency
* Thu Sep 22 2011 gber@opensuse.org
- cleanup to comply with the packaging policy
  - add header
  - use the correct license format
  - remove %%clean section
  - simplify the manipulation of PLUGIN_PATH
  - remove %%debug_package
  - add meaningful description
  - do not recompres the source tarball any more
  - corrected URLs
* Tue Jun  7 2011 pascal.bleser@opensuse.org
- fix bnc#688484 by passing --with-sound=alsa and alsa-devel in
  BuildRequires
* Wed Nov 17 2010 pascal.bleser@opensuse.org
- rewrote most of the spec file (wrong group, wrong subpackages,
  ldconfig called on devel package, shlibs inj devel package, ...)
- update to 0.8.2:
  * libfreerdp:
    + fix buffer overflow when local timezone doesn't fit in 32
    bytes
    + fix data corruption after TLS license package
    + free TLS resources to avoid memory leaks
  * mcs:
    + fix connecting to VirtualBox with extra channels
  * rdpsnd plugin:
    + ensure the ALSA device is closed when freeing resources
  * rdpdr plugin:
    + fix various memory leaks
    + fix a segfault in multi-session environment
* Wed Oct 27 2010 hrustov@gmail.com
- initial build
